diff -x asm -Naur linux-2.4.30-orig/drivers/ide/au1xxx/au1xxx-ide.c linux-2.4.30/drivers/ide/au1xxx/au1xxx-ide.c
--- linux-2.4.30-orig/drivers/ide/au1xxx/au1xxx-ide.c	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/drivers/ide/au1xxx/au1xxx-ide.c	2006-12-11 18:18:37.000000000 +0100
@@ -29,25 +29,36 @@
  *  Note: for more information, please refer "AMD Alchemy Au1200/Au1550 IDE
  *        Interface and Linux Device Driver" Application Note.
  */
-
 #undef REALLY_SLOW_IO		/* most systems can safely undef this */
 
 #include <linux/config.h>	/* for CONFIG_BLK_DEV_IDEPCI */
 #include <linux/types.h>
 #include <linux/module.h>
 #include <linux/kernel.h>
-#include <linux/delay.h>
-#include <linux/timer.h>
-#include <linux/mm.h>
-#include <linux/ioport.h>
 #include <linux/ide.h>
-#include <linux/hdreg.h>
 #include <linux/init.h>
 
 #include <asm/io.h>
 #include <asm/au1000.h>
 #include <asm/au1xxx_dbdma.h>
 
+#if defined(CONFIG_BLK_DEV_IDE_PCMCIA_AU1XXX)
+#include <pcmcia/version.h>
+#include <pcmcia/cs_types.h>
+#include <pcmcia/cs.h>
+#include <pcmcia/ss.h>
+#include <pcmcia/bulkmem.h>
+#include <pcmcia/cistpl.h>
+#include <pcmcia/bus_ops.h>
+
+#define MAX_IO_WIN 2
+/* Maximum number of memory windows per socket */
+#define MAX_WIN 4
+
+// need these two defs
+#include <asm/au1000_pcmcia.h>
+#endif
+
 /*
  * Platform dependent header files
  */
@@ -60,6 +71,9 @@
 #elif defined(CONFIG_MIPS_DB1550)
 #include <asm/db1x00.h>
 
+#elif defined(CONFIG_MIPS_I3_MMB3)
+#include <asm/mood300.h>
+
 #elif defined(CONFIG_MIPS_PB1200)
 #include <asm/pb1200.h>
 
@@ -72,15 +86,34 @@
 
 #include <linux/config.h>
 
+#undef DEBUG
+#ifdef DEBUG
+#define debug_printk(...) printk(...)
+#else
+#define debug_printk(...)
+#endif
+
 #if !defined(CONFIG_BLK_DEV_IDE_PIO_AU1XXX)
 
 #if defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
 #define DMA_WAIT_TIMEOUT	100
-#define NUM_DESCRIPTORS		64
-#else //CONFIG_BLK_DEV_IDE_PIO_DBDMA_AU1XXX 
+#define NUM_DESCRIPTORS		128
+#else
 #define NUM_DESCRIPTORS		2
+#endif // end CONFIG_BLK_DEV_IDE_PIO_DBDMA_AU1XXX
+
+/*
+ * the numb er of descriptors must be linked the number of RQSIZE; max transfer sectors 
+ * Thus NUM_DESCRIPTORS = RQSIZE must be maintained
+ */
+#if !defined(AU1XXX_ATA_RQSIZE) || !defined(CONFIG_BLK_DEV_IDE_SEQTS_PER_RQ_AU1XXX)
+#define AU1XXX_ATA_RQSIZE	NUM_DESCRIPTORS
 #endif
 
+/* set the minimum request size and its defult */
+#define AU1XXX_MIN_RQSIZE	8
+#define AUIDE_MIN_MAX(val, min, max)	(((val > max) || (val < min)) ? max : val)
+
 typedef struct
 {
 	u32			tx_dev_id, rx_dev_id;
@@ -111,24 +144,62 @@
 	{ "WDC WD200BB-00AUA1"	,	"ALL"		},
 	{0,0}
 };
-
-#if !defined(AU1XXX_ATA_RQSIZE)
-#define AU1XXX_ATA_RQSIZE	128
-#endif
 #endif /* end !CONFIG_BLK_DEV_IDE_PIO_AU1XXX */
 
 // Boot options
+#if defined(CONFIG_BLK_DEV_IDE_PCMCIA_AU1XXX)
+static phys_t auide_base = (phys_t)0;
+// ddma physical address
+static int auide_pcmcia_base = 0;
+#else
 static int auide_base=KSEG1ADDR(AU1XXX_ATA_PHYS_ADDR);
+#endif
 static int auide_len=AU1XXX_ATA_PHYS_LEN;
 static int auide_irq=AU1XXX_ATA_INT;
 
+//#define LASSE
+//#define LASSE0
+//#define KCN
+//#define KCN_EXPERIMENT
+
+u16 write_data[4096*4] = {0};
+
+#if !defined(CONFIG_BLK_DEV_IDE_PIO_AU1XXX)
+static int in_drive_list(struct hd_driveid *id, struct drive_list_entry * drive_table)
+{
+	for ( ; drive_table->id_model ; drive_table++)
+		if ((!strcmp(drive_table->id_model, id->model)) &&
+		    ((strstr(drive_table->id_firmware, id->fw_rev)) ||
+		     (!strcmp(drive_table->id_firmware, "ALL"))))
+			return 1;
+	return 0;
+}
+#endif /* end !CONFIG_BLK_DEV_IDE_PIO_AU1XXX */
+
+/*
+ * Get the CPU ID
+ */
+static u32 get_config0(void)
+{
+        u32 temp = 0;
+  
+        asm volatile (" mfc0 %0,$16 ":"=r"(temp));
+        return temp;
+}
 
 /*
  * local I/O functions
  */
 u8 auide_inb(unsigned long port)
 {
-	return (au_readb(port));
+#ifdef MAD_DEBUG
+    u8 tmp;
+    tmp = au_readb(port);
+    printk("auide_inb: 0x%02x\n", tmp & 0xff);
+    return tmp;
+#else
+	return au_readb(port);
+#endif
 }
 
 u16 auide_inw(unsigned long port)
@@ -143,6 +214,10 @@
 
 void auide_insw(unsigned long port, void *addr, u32 count)
 {
+#ifdef LASSE0
+	printk("%s[%d]\n", __FUNCTION__, (int)count);
+#endif
+
 #if defined(CONFIG_BLK_DEV_IDE_PIO_DBDMA_AU1XXX)
 	_auide_hwif *ahwif = &auide_hwif;
 	chan_tab_t		*ctp;
@@ -154,7 +229,7 @@
 	}
         ctp = *((chan_tab_t **)ahwif->rx_chan);
 	dp = ctp->cur_ptr;
-	while (dp->dscr_cmd0 & DSCR_CMD0_V)
+ 	while (dp->dscr_cmd0 & DSCR_CMD0_V)
 		;
         ctp->cur_ptr = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
 #else
@@ -178,7 +253,7 @@
 
 void auide_outb(u8 addr, unsigned long port)
 {
-	return (au_writeb(addr, port));
+	au_writeb(addr, port);
 }
 
 void auide_outbsync(ide_drive_t *drive, u8 addr, unsigned long port)
@@ -198,11 +273,14 @@
 
 void auide_outsw(unsigned long port, void *addr, u32 count)
 {
+#ifdef LASSE0
+	printk("%s @%x[%d]\n", __FUNCTION__, (int)addr, (int)count);
+#endif
+
 #if defined(CONFIG_BLK_DEV_IDE_PIO_DBDMA_AU1XXX)
 	_auide_hwif *ahwif = &auide_hwif;
 	chan_tab_t		*ctp;
 	au1x_ddma_desc_t	*dp;
-
 	if(!au1xxx_dbdma_put_source_flags(ahwif->tx_chan, (void*)addr, count << 1, DDMA_FLAGS_NOIE)) {
 		printk(KERN_ERR "%s failed %d\n", __FUNCTION__, __LINE__);
 		return;
@@ -235,17 +313,6 @@
  * Multi-Word DMA + DDMA functions
  */
 #if defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
-
-static int in_drive_list(struct hd_driveid *id, struct drive_list_entry * drive_table)
-{
-	for ( ; drive_table->id_model ; drive_table++)
-		if ((!strcmp(drive_table->id_model, id->model)) &&
-		    ((strstr(drive_table->id_firmware, id->fw_rev)) ||
-		     (!strcmp(drive_table->id_firmware, "ALL"))))
-			return 1;
-	return 0;
-}
-
 static int auide_build_sglist(ide_hwif_t *hwif, struct request *rq, int data_dir)
 {
 	_auide_hwif *ahwif = (_auide_hwif*)hwif->hwif_data;
@@ -303,6 +370,7 @@
 
 	if(nents == 0)
 		BUG();
+
 	return pci_map_sg(hwif->pci_dev, sg, nents, data_dir);
 }
 
@@ -370,6 +438,7 @@
 
 	/* fill the descriptors */
 	sg = ahwif->sg_table;
+
 	while (i && sg_dma_len(sg)) {
 		u32 cur_addr;
 		u32 cur_len;
@@ -406,6 +475,7 @@
 		sg++;
 		i--;
 	}
+
 	if (count)
 		return 1;
 use_pio_instead:
@@ -433,7 +503,9 @@
 	struct request *rq = HWGROUP(drive)->rq;
 	u8 lba48 = (drive->addressing == 1) ? 1 : 0;
 	task_ioreg_t command = WIN_NOP;
-
+#ifdef LASSE0
+	printk("%s\n", __FUNCTION__);
+#endif
 	if (!auide_build_dmatable(drive, rq, PCI_DMA_FROMDEVICE)) {
 		/* try PIO instead of DMA */
 		return 1;
@@ -441,7 +513,6 @@
 	drive->waiting_for_dma = 1;
 	if (drive->media != ide_disk)
 		return 0;
-
 	/*
 	 * FIX ME to use only ACB ide_task_t args Struct
 	 */
@@ -452,7 +523,11 @@
 	}
 
 	/* issue cmd to drive */
+#if 1 // AMD_PATCH
+	ide_execute_command(drive, command, &ide_dma_intr, WAIT_CMD, NULL);
+#else
 	ide_execute_command(drive, command, &ide_dma_intr, (2*WAIT_CMD), NULL);
+#endif
 	return auide_dma_begin(drive);
 }
 
@@ -462,6 +537,10 @@
 	u8 lba48 = (drive->addressing == 1) ? 1 : 0;
 	task_ioreg_t command = WIN_NOP;
 
+#ifdef LASSE0
+	printk("%s\n", __FUNCTION__);
+#endif
+
 	if (!auide_build_dmatable(drive, rq, PCI_DMA_TODEVICE))
 		/* try PIO instead of DMA */
 		return 1;
@@ -479,7 +558,11 @@
 	}
 
 	/* issue cmd to drive */
+#if 1 // AMD_PATCH
+	ide_execute_command(drive, command, &ide_dma_intr, WAIT_CMD, NULL);
+#else
 	ide_execute_command(drive, command, &ide_dma_intr, (2*WAIT_CMD), NULL);
+#endif
 	return auide_dma_begin(drive);
 }
 
@@ -539,6 +622,9 @@
 {
 	_auide_hwif *ahwif = (_auide_hwif*)param;
 	ahwif->drive->waiting_for_dma = 0;
+#if defined(KCN)
+	printk(">");
+#endif
 	return;
 }
 
@@ -546,6 +632,9 @@
 {
 	_auide_hwif *ahwif = (_auide_hwif*)param;
 	ahwif->drive->waiting_for_dma = 0;
+#if defined(KCN)
+	printk("<");
+#endif
 	return;
 }
 #endif /* end CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX */
@@ -554,27 +643,56 @@
 static int auide_ddma_init( _auide_hwif *auide )
 {
 	dbdev_tab_t dev;
+	au1x_ddma_desc_t *dp;
+	int i;
 #if defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
 	ide_hwif_t *hwif = auide->hwif;
 #endif
 	/* Add our custom device to DDMA device table */
 	/* Create our new device entries in the table */
+	// AMD_PATCH
+	memset(&dev, '\0', sizeof(dbdev_tab_t));
+
 #if defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
 	dev.dev_id = AU1XXX_ATA_DDMA_REQ;
 #else
 	dev.dev_id = DSCR_CMD0_ALWAYS;
 #endif
-	dev.dev_flags = DEV_FLAGS_OUT|DEV_FLAGS_SYNC|DEV_FLAGS_BURSTABLE;
 
+#if defined(CONFIG_BLK_DEV_IDE_PCMCIA_AU1XXX)
+	/*
+	 * Statis of the BURSTABLE FIFO:
+	 * Example of 4096B read.
+	 * 1) Read 512B at the first asserted DMA REQ until it is negated.
+	 * 2) After the second DMAREQ comes then the DDMA engine never resume the transaction.
+	 * Note: the transaction speed is twice slower (2 beats) than normal transaction speed (16 beats).
+	 */
+//	dev.dev_flags = DEV_FLAGS_OUT|DEV_FLAGS_SYNC|DEV_FLAGS_BURSTABLE;
+	dev.dev_flags = DEV_FLAGS_OUT|DEV_FLAGS_SYNC;
+	// we over-ride these values later
 	dev.dev_tsize = 8;
 	dev.dev_devwidth = 32;
+#else
+	dev.dev_flags = DEV_FLAGS_OUT|DEV_FLAGS_SYNC|DEV_FLAGS_BURSTABLE;
+	dev.dev_tsize = 8;
+	dev.dev_devwidth = 32;
+#endif
 
+#if defined(CONFIG_BLK_DEV_IDE_PCMCIA_AU1XXX)
+	dev.dev_physaddr = (u32)auide_pcmcia_base;
+	debug_printk("PCMCIA lower addr =%x\n", auide_pcmcia_base);
+#else
 	dev.dev_physaddr = (u32)AU1XXX_ATA_PHYS_ADDR;
+#endif
 	dev.dev_intlevel = 0;
 	dev.dev_intpolarity = 0;
 	auide->tx_dev_id = au1xxx_ddma_add_device( &dev );
 
+#if defined(CONFIG_BLK_DEV_IDE_PCMCIA_AU1XXX)
+	dev.dev_flags = DEV_FLAGS_IN|DEV_FLAGS_SYNC;
+#else
 	dev.dev_flags = DEV_FLAGS_IN|DEV_FLAGS_SYNC|DEV_FLAGS_BURSTABLE;
+#endif
 	auide->rx_dev_id = au1xxx_ddma_add_device( &dev );
 
 #if  defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
@@ -589,9 +707,51 @@
 	auide->tx_chan = au1xxx_dbdma_chan_alloc( DSCR_CMD0_ALWAYS, auide->tx_dev_id, NULL, (void*)auide );
 	auide->rx_chan = au1xxx_dbdma_chan_alloc( auide->rx_dev_id, DSCR_CMD0_ALWAYS, NULL, (void*)auide );
 #endif
+#if defined(CONFIG_BLK_DEV_IDE_PCMCIA_AU1XXX)
+	/* Tx/Rx src1/dest1 device width */
+	// org 16, 16
+	/* Tx/Rx src1/dest1 transfer size */
+	// org 1, 1
+	// 1, 2, 4, 8 datums
+	_au1xxx_dbdma_set_transfer_size(auide->tx_chan, 8, 8);
+	_au1xxx_dbdma_set_transfer_size(auide->rx_chan, 8, 8);
+#endif
+	_au1xxx_dbdma_set_devwidth(auide->tx_chan, 16, 16);
+	_au1xxx_dbdma_set_devwidth(auide->rx_chan, 16, 16);
+
+#if 1 // AMD_PATCH
+	/*
+	 * the number of ddma descriptor should be same as the rqsize
+	 * sanity check if the auide_probe() is not invoked yet
+	 */
+	if (!hwif->rqsize) {
+		hwif->rqsize = AUIDE_MIN_MAX(hwif->rqsize, AU1XXX_MIN_RQSIZE, AU1XXX_ATA_RQSIZE);
+	}
+
+	auide->tx_desc_head = (void*)au1xxx_dbdma_ring_alloc( auide->tx_chan, hwif->rqsize );
+	// Fix address bits 32-35 and set MEM bit for faster operation
+	dp = auide->tx_desc_head;
+	for (i=0; i<hwif->rqsize; i++) {
+	  dp->dscr_cmd0 |= DSCR_CMD0_MEM;
+	  dp->dscr_cmd1 |= DSCR_CMD1_DUPTR(0x0f);
+	  dp++;
+	}
+
+      	auide->rx_desc_head = (void*)au1xxx_dbdma_ring_alloc( auide->rx_chan, hwif->rqsize );
+	// Fix address bits 32-35 and set MEM bit for faster operation
+	dp = auide->rx_desc_head;
+	for (i=0; i<hwif->rqsize; i++) {
+	  dp->dscr_cmd0 |= DSCR_CMD0_MEM;
+	  dp->dscr_cmd1 |= DSCR_CMD1_SUPTR(0x0f);
+	  dp++;
+	}
+
+#else
 	auide->tx_desc_head = (void*)au1xxx_dbdma_ring_alloc( auide->tx_chan, NUM_DESCRIPTORS );
 	auide->rx_desc_head = (void*)au1xxx_dbdma_ring_alloc( auide->rx_chan, NUM_DESCRIPTORS );
 
+#endif
+
 #if defined(CONFIG_BLK_DEV_IDE_DMA_DBDMA_AU1XXX)
 	hwif->dmatable_cpu = pci_alloc_consistent(hwif->pci_dev,
 						  PRD_ENTRIES * PRD_BYTES,	/* 1 Page */
@@ -625,6 +785,25 @@
 #endif
 	au1xxx_dbdma_start( auide->tx_chan );
 	au1xxx_dbdma_start( auide->rx_chan );
+#if 1
+	/* AMD_PATCH */
+ 	{
+		extern void dump_tlb_all(void);
+		dump_tlb_all();
+	}
+
+	debug_printk("MEM_STADDR0=%x\n", au_readl(MEM_STADDR0));
+	debug_printk("MEM_STADDR1=%x\n", au_readl(MEM_STADDR1));
+	debug_printk("MEM_STADDR2=%x\n", au_readl(MEM_STADDR2));
+	debug_printk("MEM_STADDR3=%x\n", au_readl(MEM_STADDR3));
+	debug_printk("SYS_CPUPLL=%x\n", au_readl(SYS_CPUPLL));
+	debug_printk("config0=%x\n", get_config0());
+
+// AMD_PATCH
+	/* this change must be accomplished with other clock setup including DDR, baud rate, etc. */
+//	au_writel(0x0000001c, SYS_CPUPLL); // 336
+//	au_writel(0x0000001d, SYS_CPUPLL); // 348
+#endif
 	return 0;
 }
 #endif /* end DMA + Dbdma || PIO + Dbdma*/
@@ -638,6 +817,14 @@
 		*ata_regs++ = (ide_ioreg_t) auide_base + (ide_ioreg_t)(i << AU1XXX_ATA_REG_OFFSET);
 	/* set the Alternative Status register */
 	*ata_regs = (ide_ioreg_t) auide_base + (ide_ioreg_t)(14 << AU1XXX_ATA_REG_OFFSET);
+#if 0 //defined(CONFIG_BLK_DEV_IDE_PCMCIA_AU1XXX)
+	printk("BASE=%x OFFSET=%d ", auide_base, AU1XXX_ATA_REG_OFFSET);
+	ata_regs = hw->io_ports;
+	for (i = 0; i < IDE_CONTROL_OFFSET; i++) {
+		printk("%x\n", *ata_regs++);
+	}
+	printk("%x\n", *ata_regs);
+#endif
 }
 
 /*
@@ -651,14 +838,17 @@
 static int auide_default_irq(ide_ioreg_t base)
 {
 	switch (base) {
-		case KSEG1ADDR(AU1XXX_ATA_PHYS_ADDR): return ((int)auide_irq);
-		case 0x1f0: return 14;
+		case 0x1f0: printk("IDE default IRQ=%d\n", auide_irq); return ((int)auide_irq);
 		case 0x170: return 15;
 		case 0x1e8: return 11;
 		case 0x168: return 10;
 		case 0x1e0: return 8;
 //		case 0x160: return 12;
 		default:
+#if defined(CONFIG_BLK_DEV_IDE_PCMCIA_AU1XXX)
+		  printk("%s=%x\n", __FUNCTION__, (unsigned int)base);
+			if (base == auide_base) return ((int)auide_irq);
+#endif
 			return 0;
 	}
 }
@@ -686,13 +876,28 @@
 
 	/* claim the first hwif for the Au1xxx IDE driver */
 	if (reg == auide_base) {
-		if (!auide_base)
-		{
-			printk(KERN_ERR "%s Null auide_base, data_port=%x\n", __FUNCTION__, (unsigned int)data_port);
+		if (!auide_base) {
+			debug_printk(KERN_ERR "%s Null auide_base, data_port=%x\n", __FUNCTION__, (unsigned int)data_port);
+#if defined(CONFIG_BLK_DEV_IDE_PCMCIA_AU1XXX)
+			/* 
+			 * map the PCMCIA SOCKET #1 I/O region
+			 * socket #0: AU1X_SOCK0_IO
+			 */
+			auide_base = (u32)ioremap(AU1X_SOCK0_IO, AU1XXX_ATA_PHYS_LEN);
+			// Lower 32 bits of the physical address for the DDMA to use
+			// Bits 32-35 is set after descriptor ring allocation
+			auide_pcmcia_base = (int)(AU1X_SOCK0_IO & 0xffffffff);
+			if (irq != NULL) {
+				debug_printk("Auide_IRQ=%x, base=%x ddma_base=%x\n",
+				       auide_irq, (unsigned int)auide_base, auide_pcmcia_base);
+				*irq = (int)auide_irq;
+			}
+#else
 			return;
+#endif
+
 		}
 		auide_setup_ports(hw);
-
 		if (irq != NULL)
 			*irq = (int)auide_irq;
 	}
@@ -757,11 +962,11 @@
 
 #if defined(CONFIG_BLK_DEV_IDE_SEQTS_PER_RQ_AU1XXX)
 	hwif->rqsize = CONFIG_BLK_DEV_IDE_SEQTS_PER_RQ_AU1XXX;
-	hwif->rqsize = ((hwif->rqsize > AU1XXX_ATA_RQSIZE) || (hwif->rqsize < 32)) ? AU1XXX_ATA_RQSIZE : hwif->rqsize;
+	/* AMD_PATCH; reduced min as 8 from 32 */ 
+	hwif->rqsize = AUIDE_MIN_MAX(hwif->rqsize, AU1XXX_MIN_RQSIZE, AU1XXX_ATA_RQSIZE);
 #else // if kernel config is not set
 	hwif->rqsize = AU1XXX_ATA_RQSIZE;
 #endif
-
 	hwif->ultra_mask = 0x0;		 /* Disable Ultra DMA */
 #if !defined(CONFIG_BLK_DEV_IDE_PIO_AU1XXX)
 	hwif->mwdma_mask = 0x07;	/* Multimode-2 DMA  */
@@ -825,10 +1030,25 @@
 	auide_hwif.hwif = hwif;
 	hwif->hwif_data = &auide_hwif;
 	auide_ddma_init(&auide_hwif);
+#if defined(CONFIG_BLK_DEV_IDE_PCMCIA_AU1XXX)
+{	
+	u32 mem_sttime0 = au_readl(MEM_STTIME0);
+	u32 mem_stcfg0 = au_readl(MEM_STCFG0);
+
+	debug_printk("Ddma RX channel mem_sttime0=%x, %x\n", mem_stcfg0, mem_sttime0);
+#if 0
+	au1xxx_dbdma_dump(auide_hwif.rx_chan);
+
+	printk("Ddma TX channel\n");
+	au1xxx_dbdma_dump(auide_hwif.tx_chan);
+#endif /* 0 */
+}
+#endif
 #endif
 	return 0;
 }
 
+#if 0
 static int __init auide_setup (char* options)
 {
 	char* this_opt;
@@ -848,6 +1068,6 @@
 
 	return 0;
 }
-__setup("auide=", auide_setup);
+#endif
 
 EXPORT_NO_SYMBOLS;
diff -x asm -Naur linux-2.4.30-orig/drivers/ide/ide-probe.c linux-2.4.30/drivers/ide/ide-probe.c
--- linux-2.4.30-orig/drivers/ide/ide-probe.c	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/drivers/ide/ide-probe.c	2006-12-11 18:18:37.000000000 +0100
@@ -1384,16 +1384,35 @@
 	NULL
 };
 
+static void _ide_delay_2000ms (void)
+{
+#ifndef CONFIG_BLK_DEV_IDECS
+	mdelay(2000);
+#else
+	kprint ("_ide_delay_1000ms %d\n", 1+(10 * HZ)/20);
+	__set_current_state(TASK_UNINTERRUPTIBLE);
+	schedule_timeout(1+(40 * HZ)/20);
+	//schedule_timeout(1+HZ/20);
+#endif /* CONFIG_BLK_DEV_IDECS */
+}
+
+
 int ideprobe_init (void)
 {
 	unsigned int index;
 	int probe[MAX_HWIFS];
 	
 	MOD_INC_USE_COUNT;
+
 	memset(probe, 0, MAX_HWIFS * sizeof(int));
-	for (index = 0; index < MAX_HWIFS; ++index)
-		probe[index] = !ide_hwifs[index].present;
 
+	printk ("ideprobe_init: Delaying ideprobe\n");
+	_ide_delay_2000ms();
+	printk ("ideprobe_init: Delay done\n");
+	
+	for (index = 0; index < MAX_HWIFS; ++index)
+	    probe[index] = !ide_hwifs[index].present;
+	
 	/*
 	 * Probe for drives in the usual way.. CMOS/BIOS, then poke at ports
 	 */
diff -x asm -Naur linux-2.4.30-orig/drivers/input/uinput.c linux-2.4.30/drivers/input/uinput.c
--- linux-2.4.30-orig/drivers/input/uinput.c	2005-05-12 17:57:23.000000000 +0200
+++ linux-2.4.30/drivers/input/uinput.c	2006-12-11 18:18:37.000000000 +0100
@@ -1,7 +1,9 @@
 /*
  *  User level driver support for input subsystem
+ *  with scancode parser from drivers/char/pc_keyb.c
  *
  * Heavily based on evdev.c by Vojtech Pavlik
+ * scancode parser added by Anders Nystrom, South Pole, for i3 micro
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -34,6 +36,8 @@
 #include <linux/miscdevice.h>
 #include <linux/uinput.h>
 
+
+
 static int uinput_dev_open(struct input_dev *dev)
 {
 	return 0;
@@ -235,6 +239,24 @@
 
 		if (copy_from_user(&ev, buffer, sizeof(struct input_event)))
 			return -EFAULT;
+
+		/* i3 */
+		if (ev.type == EV_MSC && ev.code == MSC_SCAN) {
+			/*
+			 * translate EV_MSC/MSC_SCAN/scancode
+			 * to EV_KEY/<keycode>/<make/break>
+			 */
+			unsigned char keycode;
+
+			if (pckbd_translate(ev.value, &keycode, 1)) {
+				ev.type = EV_KEY;
+				ev.code = keycode;
+				ev.value = (ev.value&0x80) ? 0 : 1;
+			} else {
+				return count;
+			}
+		}
+		/* /i3 */
 		input_event(udev->dev, ev.type, ev.code, ev.value);
 	}
 	else
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/Config.in linux-2.4.30/drivers/mtd/Config.in
--- linux-2.4.30-orig/drivers/mtd/Config.in	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/drivers/mtd/Config.in	2006-12-11 18:18:37.000000000 +0100
@@ -1,5 +1,5 @@
 
-# $Id: Config.in,v 1.76 2004/04/01 10:17:40 gthomas Exp $
+# $Id: Config.in,v 1.2 2005/09/28 14:18:53 lel Exp $
 
 mainmenu_option next_comment
 comment 'Memory Technology Devices (MTD)'
@@ -11,14 +11,16 @@
    if [ "$CONFIG_MTD_DEBUG" = "y" ]; then
       int '  Debugging verbosity (0 = quiet, 3 = noisy)' CONFIG_MTD_DEBUG_VERBOSE 0
    fi
-   dep_tristate '  MTD partitioning support' CONFIG_MTD_PARTITIONS $CONFIG_MTD
+   bool '  MTD partitioning support' CONFIG_MTD_PARTITIONS $CONFIG_MTD
    dep_tristate '  MTD concatenating support' CONFIG_MTD_CONCAT $CONFIG_MTD
    dep_tristate '  RedBoot partition table parsing' CONFIG_MTD_REDBOOT_PARTS $CONFIG_MTD_PARTITIONS
    if [ "$CONFIG_MTD_REDBOOT_PARTS" = "y" -o "$CONFIG_MTD_REDBOOT_PARTS" = "m" ]; then
       bool '  Include unallocated flash space' CONFIG_MTD_REDBOOT_PARTS_UNALLOCATED
       bool '  Force read-only for RedBoot system images' CONFIG_MTD_REDBOOT_PARTS_READONLY
    fi
-   dep_tristate '  Command line partition table parsing' CONFIG_MTD_CMDLINE_PARTS $CONFIG_MTD_PARTITIONS
+   if [ "$CONFIG_MTD_PARTITIONS" = "y" ]; then
+      bool '  Command line partition table parsing' CONFIG_MTD_CMDLINE_PARTS 
+   fi
    if [ "$CONFIG_ARM" = "y" ]; then
       dep_tristate '  ARM Firmware Suite partition parsing' CONFIG_MTD_AFS_PARTS $CONFIG_MTD_PARTITIONS
    fi
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/Makefile linux-2.4.30/drivers/mtd/Makefile
--- linux-2.4.30-orig/drivers/mtd/Makefile	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/drivers/mtd/Makefile	2006-12-11 18:18:37.000000000 +0100
@@ -1,58 +1,43 @@
 #
-# Makefile for the memory technology device drivers.
+# linux/drivers/Makefile.24
+# Makefile for obsolete kernels.
 #
-# $Id: Makefile.common,v 1.2 2003/05/23 11:38:29 dwmw2 Exp $
-
-#                       *** BIG UGLY NOTE ***
-#
-# The shiny new inter_module_xxx has introduced yet another ugly link
-# order dependency, which I'd previously taken great care to avoid.
-# We now have to ensure that the chip drivers are initialised before the
-# map drivers, and that the doc200[01] drivers are initialised before
-# docprobe.
-#
-# We'll hopefully merge the doc200[01] drivers and docprobe back into
-# a single driver some time soon, but the CFI drivers are going to have
-# to stay like that.
-#
-# Urgh.
-# 
-# dwmw2 21/11/0
+# $Id: Makefile,v 1.2 2005/09/28 14:18:53 lel Exp $
 
 # Core functionality.
-obj-$(CONFIG_MTD)		+= mtdcore.o
-obj-$(CONFIG_MTD_CONCAT)	+= mtdconcat.o
-obj-$(CONFIG_MTD_PARTITIONS)	+= mtdpart.o
+mtd-y				:= mtdcore.o
+mtd-$(CONFIG_MTD_PARTITIONS)	+= mtdpart.o
+obj-$(CONFIG_MTD)		+= $(mtd-y)
+
+obj-$(CONFIG_MTD_CONCAT)        += mtdconcat.o
 obj-$(CONFIG_MTD_REDBOOT_PARTS) += redboot.o
 obj-$(CONFIG_MTD_CMDLINE_PARTS) += cmdlinepart.o
-obj-$(CONFIG_MTD_AFS_PARTS)	+= afs.o
+obj-$(CONFIG_MTD_AFS_PARTS)     += afs.o
 
 # 'Users' - code which presents functionality to userspace.
-obj-$(CONFIG_MTD_CHAR)		+= mtdchar.o
-obj-$(CONFIG_MTD_BLOCK)		+= mtdblock.o mtd_blkdevs.o
-obj-$(CONFIG_MTD_BLOCK_RO)	+= mtdblock_ro.o mtd_blkdevs.o
-obj-$(CONFIG_FTL)		+= ftl.o mtd_blkdevs.o
-obj-$(CONFIG_NFTL)		+= nftl.o mtd_blkdevs.o
-obj-$(CONFIG_INFTL)		+= inftl.o mtd_blkdevs.o
-
-nftl-objs		:= nftlcore.o nftlmount.o
-inftl-objs		:= inftlcore.o inftlmount.o
+obj-$(CONFIG_MTD_CHAR)          += mtdchar.o
+obj-$(CONFIG_MTD_BLOCK)         += mtdblock.o mtd_blkdevs-24.o
+obj-$(CONFIG_MTD_BLOCK_RO)      += mtdblock_ro.o mtd_blkdevs-24.o
+obj-$(CONFIG_FTL)               += ftl.o mtd_blkdevs-24.o
+obj-$(CONFIG_NFTL)              += nftl.o mtd_blkdevs-24.o
+obj-$(CONFIG_INFTL)             += inftl.o mtd_blkdevs-24.o
 
-ifeq ($(PATCHLEVEL),4)
+nftl-objs               := nftlcore.o nftlmount.o
+inftl-objs              := inftlcore.o inftlmount.o
 
 export-objs	:= mtdcore.o mtdpart.o redboot.o cmdlinepart.o afs.o \
 		   mtdconcat.o mtd_blkdevs-24.o
 
-mtd_blkdevs-objs	:= mtd_blkdevs-24.o
+mtd_blkdevs-objs := mtd_blkdevs-24.o
 
-obj-y           += chips/chipslink.o maps/mapslink.o \
-			devices/devlink.o nand/nandlink.o
+obj-y		+= chips/chipslink.o maps/mapslink.o \
+		   devices/devlink.o nand/nandlink.o
 
 O_TARGET	:= mtdlink.o
 
-list-multi	:= nftl.o inftl.o mtd_blkdevs.o
+list-multi	:= nftl.o inftl.o mtd_blkdevs-24.o
 
-mod-subdirs	:= 
+mod-subdirs	:=
 subdir-y	:= chips maps devices nand
 subdir-m	:= $(subdir-y)
 
@@ -67,6 +52,3 @@
 mtd_blkdevs.o: $(mtd_blkdevs-objs)
 	$(LD) -r -o $@ $(mtd_blkdevs-objs)
 
-else
-obj-y		+= chips/ maps/ devices/ nand/
-endif
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/Makefile.common linux-2.4.30/drivers/mtd/Makefile.common
--- linux-2.4.30-orig/drivers/mtd/Makefile.common	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30/drivers/mtd/Makefile.common	2006-12-11 18:18:37.000000000 +0100
@@ -0,0 +1,27 @@
+#
+# Makefile for the memory technology device drivers.
+#
+# $Id: Makefile.common,v 1.2 2005/09/28 14:18:53 lel Exp $
+
+# Core functionality.
+mtd-y				:= mtdcore.o
+mtd-$(CONFIG_MTD_PARTITIONS)	+= mtdpart.o
+obj-$(CONFIG_MTD)		+= $(mtd-y)
+
+obj-$(CONFIG_MTD_CONCAT)	+= mtdconcat.o
+obj-$(CONFIG_MTD_REDBOOT_PARTS) += redboot.o
+obj-$(CONFIG_MTD_CMDLINE_PARTS) += cmdlinepart.o
+obj-$(CONFIG_MTD_AFS_PARTS)	+= afs.o
+
+# 'Users' - code which presents functionality to userspace.
+obj-$(CONFIG_MTD_CHAR)		+= mtdchar.o
+obj-$(CONFIG_MTD_BLOCK)		+= mtdblock.o mtd_blkdevs.o
+obj-$(CONFIG_MTD_BLOCK_RO)	+= mtdblock_ro.o mtd_blkdevs.o
+obj-$(CONFIG_FTL)		+= ftl.o mtd_blkdevs.o
+obj-$(CONFIG_NFTL)		+= nftl.o mtd_blkdevs.o
+obj-$(CONFIG_INFTL)		+= inftl.o mtd_blkdevs.o
+
+nftl-objs		:= nftlcore.o nftlmount.o
+inftl-objs		:= inftlcore.o inftlmount.o
+
+obj-y		+= chips/ maps/ devices/ nand/
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/afs.c linux-2.4.30/drivers/mtd/afs.c
--- linux-2.4.30-orig/drivers/mtd/afs.c	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/drivers/mtd/afs.c	2006-12-11 18:18:37.000000000 +0100
@@ -21,7 +21,7 @@
    This is access code for flashes using ARM's flash partitioning 
    standards.
 
-   $Id: afs.c,v 1.13 2004/02/27 22:09:59 rmk Exp $
+   $Id: afs.c,v 1.2 2005/09/28 14:18:53 lel Exp $
 
 ======================================================================*/
 
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/chips/Config.in linux-2.4.30/drivers/mtd/chips/Config.in
--- linux-2.4.30-orig/drivers/mtd/chips/Config.in	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/drivers/mtd/chips/Config.in	2006-12-11 18:18:37.000000000 +0100
@@ -1,6 +1,6 @@
 # drivers/mtd/chips/Config.in
 
-# $Id: Config.in,v 1.19 2004/04/15 14:24:09 thayne Exp $
+# $Id: Config.in,v 1.2 2005/09/28 14:18:59 lel Exp $
 
 mainmenu_option next_comment
 
@@ -28,11 +28,13 @@
 	 LITTLE_ENDIAN_BYTE	CONFIG_MTD_CFI_LE_BYTE_SWAP"	NO
      bool '  Specific CFI Flash geometry selection' CONFIG_MTD_CFI_GEOMETRY
      if [ "$CONFIG_MTD_CFI_GEOMETRY" = "y" ]; then
-       bool '    Support  8-bit buswidth' CONFIG_MTD_CFI_B1
-       bool '    Support 16-bit buswidth' CONFIG_MTD_CFI_B2
-       bool '    Support 32-bit buswidth' CONFIG_MTD_CFI_B4
-       bool '    Support 64-bit buswidth' CONFIG_MTD_CFI_B8
-	 if [ "$CONFIG_MTD_CFI_B1" = "y" ]; then
+       bool '    Support   8-bit buswidth' CONFIG_MTD_MAP_BANK_WIDTH_1
+       bool '    Support  16-bit buswidth' CONFIG_MTD_MAP_BANK_WIDTH_2
+       bool '    Support  32-bit buswidth' CONFIG_MTD_MAP_BANK_WIDTH_4
+       bool '    Support  64-bit buswidth' CONFIG_MTD_MAP_BANK_WIDTH_8
+       bool '    Support 128-bit buswidth' CONFIG_MTD_MAP_BANK_WIDTH_16
+       bool '    Support 256-bit buswidth' CONFIG_MTD_MAP_BANK_WIDTH_32
+	 if [ "$CONFIG_MTD_MAP_BANK_WIDTH_1" = "y" ]; then
 	   define_bool CONFIG_MTD_CFI_I1 y
          else
            bool '    Support 1-chip flash interleave' CONFIG_MTD_CFI_I1
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/chips/Makefile linux-2.4.30/drivers/mtd/chips/Makefile
--- linux-2.4.30-orig/drivers/mtd/chips/Makefile	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/drivers/mtd/chips/Makefile	2006-12-11 18:18:37.000000000 +0100
@@ -1,33 +1,12 @@
 #
-# linux/drivers/chips/Makefile
+# linux/drivers/chips/Makefile.24
+# Makefile for obsolete kernels.
 #
-# $Id: Makefile.common,v 1.3 2003/09/25 14:40:34 thayne Exp $
+# $Id: Makefile,v 1.2 2005/09/28 14:18:59 lel Exp $
 
-ifeq ($(PATCHLEVEL),4)
 O_TARGET	:= chipslink.o
 export-objs	:= chipreg.o gen_probe.o cfi_util.o
-endif
 
-#                       *** BIG UGLY NOTE ***
-#
-# The removal of get_module_symbol() and replacement with
-# inter_module_register() et al has introduced a link order dependency
-# here where previously there was none.  We now have to ensure that
-# the CFI command set drivers are linked before cfi_probe.o
-
-obj-$(CONFIG_MTD)		+= chipreg.o
-obj-$(CONFIG_MTD_AMDSTD)	+= amd_flash.o 
-obj-$(CONFIG_MTD_CFI)		+= cfi_probe.o
-obj-$(CONFIG_MTD_CFI_UTIL)	+= cfi_util.o
-obj-$(CONFIG_MTD_CFI_STAA)	+= cfi_cmdset_0020.o
-obj-$(CONFIG_MTD_CFI_AMDSTD)	+= cfi_cmdset_0002.o
-obj-$(CONFIG_MTD_CFI_INTELEXT)	+= cfi_cmdset_0001.o
-obj-$(CONFIG_MTD_GEN_PROBE)	+= gen_probe.o
-obj-$(CONFIG_MTD_JEDEC)		+= jedec.o
-obj-$(CONFIG_MTD_JEDECPROBE)	+= jedec_probe.o
-obj-$(CONFIG_MTD_RAM)		+= map_ram.o
-obj-$(CONFIG_MTD_ROM)		+= map_rom.o
-obj-$(CONFIG_MTD_SHARP)		+= sharp.o
-obj-$(CONFIG_MTD_ABSENT)	+= map_absent.o
+include Makefile.common
 
--include $(TOPDIR)/Rules.make
+include $(TOPDIR)/Rules.make
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/chips/Makefile.common linux-2.4.30/drivers/mtd/chips/Makefile.common
--- linux-2.4.30-orig/drivers/mtd/chips/Makefile.common	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30/drivers/mtd/chips/Makefile.common	2006-12-11 18:18:37.000000000 +0100
@@ -0,0 +1,26 @@
+#
+# linux/drivers/chips/Makefile
+#
+# $Id: Makefile.common,v 1.2 2005/09/28 14:18:59 lel Exp $
+
+#                       *** BIG UGLY NOTE ***
+#
+# The removal of get_module_symbol() and replacement with
+# inter_module_register() et al has introduced a link order dependency
+# here where previously there was none.  We now have to ensure that
+# the CFI command set drivers are linked before gen_probe.o
+
+obj-$(CONFIG_MTD)		+= chipreg.o
+obj-$(CONFIG_MTD_AMDSTD)	+= amd_flash.o 
+obj-$(CONFIG_MTD_CFI)		+= cfi_probe.o
+obj-$(CONFIG_MTD_CFI_UTIL)	+= cfi_util.o
+obj-$(CONFIG_MTD_CFI_STAA)	+= cfi_cmdset_0020.o
+obj-$(CONFIG_MTD_CFI_AMDSTD)	+= cfi_cmdset_0002.o
+obj-$(CONFIG_MTD_CFI_INTELEXT)	+= cfi_cmdset_0001.o
+obj-$(CONFIG_MTD_GEN_PROBE)	+= gen_probe.o
+obj-$(CONFIG_MTD_JEDEC)		+= jedec.o
+obj-$(CONFIG_MTD_JEDECPROBE)	+= jedec_probe.o
+obj-$(CONFIG_MTD_RAM)		+= map_ram.o
+obj-$(CONFIG_MTD_ROM)		+= map_rom.o
+obj-$(CONFIG_MTD_SHARP)		+= sharp.o
+obj-$(CONFIG_MTD_ABSENT)	+= map_absent.o
diff -x asm -Naur linux-2.4.30-orig/drivers/mtd/chips/amd_flash.c linux-2.4.30/drivers/mtd/chips/amd_flash.c
--- linux-2.4.30-orig/drivers/mtd/chips/amd_flash.c	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/drivers/mtd/chips/amd_flash.c	2006-12-11 18:18:37.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * Author: Jonas Holmberg <jonas.holmberg@axis.com>
  *
- * $Id: amd_flash.c,v 1.23 2003/06/12 09:24:13 dwmw2 Exp $
+ * $Id: amd_flash.c,v 1.3 2005/10/12 14:47:50 lel Exp $
  *
  * Copyright (c) 2001 Axis Communications AB
  *
@@ -67,7 +67,6 @@
 #define AM29LV160DT	0x22C4
 #define AM29LV160DB	0x2249
 #define AM29BDS323D     0x22D1
-#define AM29BDS643D	0x227E
 
 /* Atmel */
 #define AT49xV16x	0x00C0
@@ -618,17 +617,6 @@
 			{ .offset = 0x3f0000, .erasesize = 0x02000, .numblocks =  8 },
 		}
 	}, {
-		.mfr_id = MANUFACTURER_AMD,
-		.dev_id = AM29BDS643D,
-		.name = "AMD AM29BDS643D",
-		.size = 0x00800000,
-		.numeraseregions = 3,
-		.regions = {
-			{ .offset = 0x000000, .erasesize = 0x10000, .numblocks = 96 },
-			{ .offset = 0x600000, .erasesize = 0x10000, .numblocks = 31 },
-			{ .offset = 0x7f0000, .erasesize = 0x02000, .numblocks =  8 },
-		}
-	}, {
 		.mfr_id = MANUFACTURER_ATMEL,
 		.dev_id = AT49xV16x,
 		.name = "Atmel AT49xV16x",
@@ -718,7 +706,7 @@
 		       "memory for MTD erase region info\n", map->name);
 		kfree(mtd);
 		map->fldrv_priv = NULL;
-		return 0;
+		return NULL;
 	}
 
 	reg_idx = 0;
@@ -780,8 +768,8 @@
 	map->fldrv_priv = private;
 
 	map->fldrv = &amd_flash_chipdrv;
-	MOD_INC_USE_COUNT;
 
+	__module_get(THIS_MODULE);
 	return mtd;
 }
 
@@ -1122,7 +1110,7 @@
 	timeo = jiffies + (HZ * 20);
 
 	spin_unlock_bh(chip->mutex);
-	schedule_timeout(HZ);
+	msleep(1000);
 	spin_lock_bh(chip->mutex);
 	
 	while (flash_is_busy(map, adr, private->interleave)) {
@@ -1307,9 +1295,7 @@
 	}
 		
 	instr->state = MTD_ERASE_DONE;
-	if (instr->callback) {
-		instr->callback(instr);
-	}
+	mtd_erase_callback(instr);
 	
 	return 0;
 }
